﻿Imports FarPoint.Win.Spread

Public Class Form1
    Dim filterby As String()
    Dim dt As DataTable
    Dim fc1 As FilterCondition, fc2 As FilterCondition
    Dim multival As Boolean, customfil As Boolean
    Dim [and] As Boolean
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        dt = New DataTable()
        dt.Columns.AddRange(New DataColumn() {New DataColumn("FirstName"), New DataColumn("LastName")})
        dt.Rows.Add(New Object() {"Alice", "Abbot"})
        dt.Rows.Add(New Object() {"Alice", "Anderson"})
        dt.Rows.Add(New Object() {"Bill", "Abbot"})
        dt.Rows.Add(New Object() {"Bob", "Bell"})
        dt.Rows.Add(New Object() {"Bob", "Hope"})
        dt.Rows.Add(New Object() {"Jim", "Bell"})
        dt.Rows.Add(New Object() {"Cindy", "Cooper"})
        dt.Rows.Add(New Object() {"Nancy", "Cooper"})
        dt.Rows.Add(New Object() {"Cindy", "Bell"})
        fpSpread1.DataSource = dt
        fpSpread1.ActiveSheet.SetColumnAllowFilter(0, True)
        fpSpread1.ActiveSheet.AutoFilterMode = FarPoint.Win.Spread.AutoFilterMode.EnhancedContextMenu
        fpSpread2.DataSource = dt
        fpSpread2.ActiveSheet.AutoFilterMode = AutoFilterMode.EnhancedContextMenu
    End Sub

    Private Sub button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button1.Click
        Dim rf As FarPoint.Win.Spread.IRowFilter = fpSpread1.ActiveSheet.RowFilter
        For Each fcd As FilterColumnDefinition In rf.ColumnDefinitions
            Dim filters As FilterItemCollection = fcd.Filters
            Dim iFilterItem As IFilterItem = Nothing
            Dim filterString As String = fpSpread1.Sheets(0).RowFilter.GetColumnFilterBy(0)
            Dim i As Integer = 0, count As Integer = filters.Count
            While i < count
                If filters(i).DisplayName = filterString Then
                    iFilterItem = filters(i)
                    Exit While
                End If
                i += 1
            End While
            If TypeOf iFilterItem Is FarPoint.Win.Spread.MultiValuesFilterItem Then
                multival = True
                customfil = False
                Dim mvFilterItem As MultiValuesFilterItem = TryCast(iFilterItem, MultiValuesFilterItem)
                If mvFilterItem IsNot Nothing Then
                    filterby = New String(mvFilterItem.FilterItems.Count - 1) {}
                    Dim j As Integer = 0
                    For Each fi As FarPoint.Win.Spread.FilterItemValue In mvFilterItem.FilterItems
                        filterby(j) = fi.Value.ToString()
                        j += 1
                    Next
                End If
            ElseIf TypeOf iFilterItem Is FarPoint.Win.Spread.CustomFilterItem Then
                customfil = True
                multival = False
                Dim cfFilterItem As CustomFilterItem = TryCast(iFilterItem, CustomFilterItem)
                filterby = New String(2) {}
                If cfFilterItem IsNot Nothing Then
                    fc1 = cfFilterItem.FirstCondition
                    fc2 = cfFilterItem.SecondCondition
                    [and] = cfFilterItem.[And]
                End If
            End If
        Next
        MessageBox.Show("Filter state saved")
    End Sub

    Private Sub button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button2.Click
        fpSpread2.ActiveSheet.ClearRowFilter()
        fpSpread2.ActiveSheet.SetColumnAllowFilter(0, True)
        If multival Then
            Dim fc As New FilterItemValueCollection()
            For r As Integer = 0 To filterby.Length - 1
                fc.Add(New FarPoint.Win.Spread.FilterItemValue(filterby(r)))
            Next
            Dim filter As New MultiValuesFilterItem(fc)
            filter.SheetView = fpSpread2.ActiveSheet
            fpSpread2.ActiveSheet.RowFilter.ColumnDefinitions(0).Filters.Add(filter)
            fpSpread2.ActiveSheet.AutoFilterColumn(0, filter.DisplayName, 0)
            MessageBox.Show("Saved filter state applied to second spread")
        ElseIf customfil Then
            Dim cff As New CustomFilterItem(fc1, fc2, [and])
            cff.SheetView = fpSpread2.ActiveSheet
            fpSpread2.ActiveSheet.RowFilter.ColumnDefinitions(0).Filters.Add(cff)
            fpSpread2.ActiveSheet.AutoFilterColumn(0, cff.DisplayName, 0)
            MessageBox.Show("Saved filter state applied to second spread")
        End If
    End Sub
End Class
